# coding=utf-8
from plone import api
from ploneintranet import api as pi_api
from Products.Five import BrowserView


class ConfigureQuaive(BrowserView):
    """ Configure a freshly installed quaive from a single form.
    Create an admin user
    Set the title
    Set the language
    """

    def __call__(self):
        if self.request.method == "POST":
            form = self.request.form
            self.portal = api.portal.get()

            self.set_portal_title(form.get("portal_title"))
            self.add_admin_user(
                form.get("username"), form.get("email"), form.get("password")
            )
            self.set_portal_language(form.get("language"))
        return self.index()

    def set_portal_title(self, portal_title):
        self.portal.title = portal_title
        api.portal.set_registry_record("plone.site_title", portal_title)

    def add_admin_user(self, username, email, password):
        pi_api.userprofile.create(
            username=username, email=email, password=password, approve=True
        )

    def set_portal_language(self, language):
        api.portal.set_registry_record("plone.available_languages", [language])
        api.portal.set_registry_record("plone.default_language", language)
